# Match the python versions in:
# - pyproject.toml

image: python:3.6-stretch

cache:
  paths:
    - .venv/

before_script:
  ## Install project dependencies
  - curl -sSL https://raw.githubusercontent.com/sdispater/poetry/master/get-poetry.py -o /tmp/get-poetry.py
  - python /tmp/get-poetry.py
  - source ${HOME}/.poetry/env
  - poetry config settings.virtualenvs.in-project true
  ## Install the latest project dependencies (ignore the lock file)
  - rm -f poetry.lock
  - poetry run pip install --upgrade pip
  - poetry install -v --no-interaction

stages:
  - code-quality
  - code-test
  - deploy


code_quality:
  stage: code-quality
  allow_failure: true
  only:
    refs:
      - merge_requests
  script:
    - make lint
    - make typehint

code_test:
  stage: code-test
  only:
    refs:
      - master
      - merge_requests
    changes:
      - package/**/*
      - tests/**/*
      - .gitlab-ci.yml
      - Makefile
      - pyproject.toml
  script:
    - make coverage
    - make package-check

package:
  stage: deploy
  only:
    refs:
      - master
  script:
    - make package-check
  artifacts:
    paths:
      - dist/

#pages:
#  allow_failure: true
#  stage: deploy
#  only:
#    refs:
#      - master
#  script:
#    - make docs
#    - mv docs/_build/html/ public/
#  artifacts:
#    paths:
#      - public


#publish:
#  stage: deploy
#  only:
#    refs:
#      - master
#  script:
#    - make publish
#  only:
#    - tags

